Index: java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java	(revision 102)
@@ -46,6 +46,11 @@
 	}
 
-	public void fireChildrenChange(T child, ListChange.Action action) {
-		ListChange change = new ListChange(action, UniqueListAccess.getNumberInMap(children, child), child.getUid());
+	public void fireChildrenChange(ListChange original, ListChange.Action action, Object... hints) {
+		listeners.actionForAll(new ListChange(action, original.getPosition(), original.getIdentifier(), hints));
+
+	}
+
+	public void fireChildrenChange(T child, ListChange.Action action, Object... hints) {
+		ListChange change = new ListChange(action, UniqueListAccess.getNumberInMap(children, child), child.getUid(), hints);
 		listeners.actionForAll(change);
 	}
Index: java/main/src/main/java/com/framsticks/params/Sink.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/Sink.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/params/Sink.java	(revision 102)
@@ -0,0 +1,11 @@
+package com.framsticks.params;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public interface Sink {
+	Sink print(String str);
+	Sink print(Object obj);
+	void breakLine();
+	void close();
+}
Index: java/main/src/main/java/com/framsticks/params/types/BooleanParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 102)
@@ -7,5 +7,5 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
-import com.framsticks.params.SinkInterface;
+import com.framsticks.params.Sink;
 import com.framsticks.util.lang.Numbers;
 
@@ -58,5 +58,5 @@
 
 	@Override
-	public void save(SinkInterface sink, Object value) {
+	public void save(Sink sink, Object value) {
 		assert value instanceof Boolean;
 		sink.print(((Boolean)value) ? "1" : "0");
Index: java/main/src/main/java/com/framsticks/params/types/StringParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 102)
@@ -5,5 +5,5 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
-import com.framsticks.params.SinkInterface;
+import com.framsticks.params.Sink;
 
 import javax.annotation.concurrent.Immutable;
@@ -49,5 +49,5 @@
 
 	@Override
-	public void save(SinkInterface sink, Object value) {
+	public void save(Sink sink, Object value) {
 		assert value instanceof String;
 		String s = (String)value;
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 102)
@@ -15,9 +15,9 @@
 
 	protected final Schema schema;
-	protected final SinkInterface sink;
+	protected final Sink sink;
 	protected final Model model;
 	protected boolean omitDefaults = true;
 
-	public F0Writer(Schema schema, Model model, SinkInterface sink) {
+	public F0Writer(Schema schema, Model model, Sink sink) {
 		this.schema = schema;
 		this.model = model;
@@ -32,5 +32,4 @@
 	protected void write(Access access) {
 		if (access instanceof ListAccess) {
-			// TODO
 			for (ValueParam p : Containers.filterInstanceof(access.getParams(), ValueParam.class)) {
 				write(schema.getRegistry().prepareAccess((CompositeParam) p).select(access.get(p, Object.class)));
Index: java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/parsers/MultiParamLoader.java	(revision 102)
@@ -23,5 +23,4 @@
 	}
 
-	/** TODO does it support multilines? */
 	/**
 	 * Specifies the condition to break execution.
Index: java/main/src/main/java/com/framsticks/parsers/Savers.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 102)
@@ -1,6 +1,10 @@
 package com.framsticks.parsers;
 
-import com.framsticks.params.*;
-import com.framsticks.params.SinkInterface;
+import com.framsticks.params.Access;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.Param;
+import com.framsticks.params.ReflectionAccess;
+import com.framsticks.params.Sink;
+import static com.framsticks.params.AccessOperations.*;
 
 /**
@@ -8,13 +12,13 @@
  */
 public class Savers {
-	public static <S extends SinkInterface> S saveFramsClass(S sink, FramsClass framsClass) {
+	public static <S extends Sink> S saveFramsClass(S sink, FramsClass framsClass) {
 
 		Access framsClassAccess = new ReflectionAccess(FramsClass.class);
 		Access paramAccess = new ReflectionAccess(Param.class);
 		framsClassAccess.select(framsClass);
-		framsClassAccess.save(sink);
+
+		save(framsClassAccess, sink);
 		for (Param p : framsClass.getParamEntries()) {
-			paramAccess.select(p);
-			paramAccess.save(sink);
+			save(paramAccess.select(p), sink);
 		}
 		return sink;
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 102)
@@ -23,4 +23,5 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.Registry;
+import com.framsticks.util.AutoAttacher;
 import com.framsticks.util.AutoBuilder;
 import com.framsticks.util.FramsticksException;
@@ -137,5 +138,9 @@
 
 			for (Object child : childrenObjects) {
-				access.tryAutoAppend(child);
+				if (child instanceof AutoAttacher) {
+					((AutoAttacher) child).attachTo(access.getSelected());
+				} else {
+					access.tryAutoAppend(child);
+				}
 			}
 		}
Index: java/main/src/main/java/com/framsticks/remote/RemoteTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 102)
@@ -56,9 +56,13 @@
 	}
 
+	public void setAddress(Address address) {
+		this.connection = Connection.to(new ClientSideManagedConnection(), address);
+		this.connection.setExceptionHandler(this);
+		this.connection.setNeedFileAcceptor(this);
+	}
+
 	@ParamAnnotation
 	public void setAddress(String address) {
-		this.connection = Connection.to(new ClientSideManagedConnection(), new Address(address));
-		this.connection.setExceptionHandler(this);
-		this.connection.setNeedFileAcceptor(this);
+		setAddress(new Address(address));
 	}
 
@@ -72,8 +76,8 @@
 	}
 
+
 	@Override
 	public String toString() {
-		assert Dispatching.isThreadSafe();
-		return "remote tree " + getName() + "(" + getAddress() + ")";
+		return super.toString() + "[" + getAddress() + "]";
 	}
 
@@ -102,5 +106,4 @@
 	//	assert param != null;
 	//	// assert path.isResolved();
-	//	//TODO only do that if needed
 	//	connection.send(new GetRequest().field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(pathRemoveHandler(path, future)) {
 	//		@Override
@@ -116,4 +119,10 @@
 
 
+	/** Fetch information.
+ 	 *
+	 * This method does not check whether the info is already in the cache, it will always issue a request or join
+	 * with other already issued but returned info request. Too issue request only when needed, use TreeOperations.findInfo()
+	 *
+	 * */
 	@Override
 	public void info(final Path path, final Future<FramsClass> future) {
@@ -153,5 +162,4 @@
 		});
 
-		//TODO: if the info is in the cache, then don't communicate
 		connection.send(new InfoRequest().path(path.getTextual()), AtOnceDispatcher.getInstance(), new ClientSideResponseFuture(compositeFuture) {
 			@Override
@@ -203,5 +211,5 @@
 
 		log.trace("storing value {} for {}", param, path);
-		//TODO break in passing exception handler is here
+
 		connection.send(new SetRequest().value(value.toString()).field(param.getId()).path(path.getTextual()), this, new ClientSideResponseFuture(future) {
 			@Override
@@ -224,5 +232,8 @@
 					@Override
 					protected void processOk(Response response) {
-						FramsClass framsClass = processFetchedInfo(RemoteTree.this, response.getFiles().get(0));
+						assert bufferedDispatcher.getTargetDispatcher().isActive();
+						FramsClass framsClass = Loaders.loadFramsClass(response.getFiles().get(0).getContent());
+						putInfoIntoCache(framsClass);
+
 						assignRootParam(Param.build().name("Tree").id(RemoteTree.this.getName()).type("o " + framsClass.getId()).finish(CompositeParam.class));
 						bufferedDispatcher.setBuffer(false);
Index: java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 102)
@@ -22,5 +22,4 @@
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.util.FramsticksException;
-import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatching;
@@ -110,5 +109,5 @@
 				throw new FramsticksException().msg("failed to wait for process").cause(e);
 			}
-			log.debug("process ended {}", this);
+			log.info("process ended {}", this);
 			// process = null;
 		} catch (FramsticksException e) {
@@ -131,5 +130,5 @@
 	@Override
 	protected void joinableStart() {
-		log.debug("running process with arguments: {}", arguments);
+		log.debug("running process {}", this);
 		builder.command(arguments);
 		try {
@@ -160,5 +159,5 @@
 	@Override
 	public String toString() {
-		return getName() + "[" + Misc.returnNotNull(getCommand(), "?") + "]";
+		return getName() + arguments;
 	}
 
Index: java/main/src/main/java/com/framsticks/running/FramsServer.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/FramsServer.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/running/FramsServer.java	(revision 102)
@@ -1,6 +1,10 @@
 package com.framsticks.running;
 
+
+
+import com.framsticks.params.ParamFlags;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.lang.Strings;
 
 @FramsClassAnnotation
@@ -9,4 +13,5 @@
 	protected Integer port;
 	protected String path;
+	protected String expdef;
 
 	/**
@@ -23,5 +28,5 @@
 	 * @return the port
 	 */
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public Integer getPort() {
 		return port;
@@ -39,5 +44,5 @@
 	 * @return the path
 	 */
-	@ParamAnnotation
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
 	public String getPath() {
 		return path;
@@ -54,4 +59,20 @@
 	}
 
+	/**
+	 * @return the expdef
+	 */
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public String getExpdef() {
+		return expdef;
+	}
+
+	/**
+	 * @param expdef the expdef to set
+	 */
+	@ParamAnnotation
+	public void setExpdef(String expdef) {
+		this.expdef = expdef;
+	}
+
 	@Override
 	protected void joinableStart() {
@@ -60,4 +81,8 @@
 			arguments.add("-p" + port);
 		}
+		if (Strings.notEmpty(expdef)) {
+			arguments.add("Simulator.expdef=\"" + expdef + "\";");
+		}
+		// log.debug("running {} with arguments {}", getCommand(), arguments);
 		super.joinableStart();
 	}
Index: java/main/src/main/java/com/framsticks/test/PrimeExperiment.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/PrimeExperiment.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/test/PrimeExperiment.java	(revision 102)
@@ -1,9 +1,52 @@
 package com.framsticks.test;
 
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
 import com.framsticks.experiment.Experiment;
+import com.framsticks.experiment.WorkPackageLogic;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.test.prime.PrimePackage;
+import com.framsticks.util.dispatching.Future;
 
 @FramsClassAnnotation
 public class PrimeExperiment extends Experiment {
+	private static final Logger log = LogManager.getLogger(PrimeExperiment.class);
+
+	@ParamAnnotation
+	public final WorkPackageLogic<PrimePackage> workPackageLogic;
+
+	protected int maxNumber = 3000;
+	protected int step = 100;
+	protected int numberCounter = 1;
+
+	/**
+	 *
+	 */
+	public PrimeExperiment() {
+		setExpdef("prime");
+
+		workPackageLogic = new WorkPackageLogic<PrimePackage>(this) {
+
+			@Override
+			protected void generateNextPackage(Future<PrimePackage> future) {
+				assert isActive();
+				PrimePackage wp = new PrimePackage();
+
+				log.debug("generated package: {}", wp);
+				wp.params.from_number = numberCounter;
+				numberCounter += step;
+				wp.params.to_number = numberCounter - 1;
+				wp.state.current_number = wp.params.from_number;
+				wp.state.getResultList().clear();
+
+				future.pass(wp);
+			}
+		};
+	}
+
+	protected void processFile() {
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/test/prime/ExpParams.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/prime/ExpParams.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/test/prime/ExpParams.java	(revision 102)
@@ -0,0 +1,19 @@
+package com.framsticks.test.prime;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public class ExpParams {
+
+	@ParamAnnotation
+	public int from_number;
+
+	@ParamAnnotation
+	public int to_number;
+
+	@Override
+	public String toString() {
+		return "[" + from_number + ":" + to_number + "]";
+	}
+}
Index: java/main/src/main/java/com/framsticks/test/prime/ExpState.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/prime/ExpState.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/test/prime/ExpState.java	(revision 102)
@@ -0,0 +1,43 @@
+package com.framsticks.test.prime;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.apache.commons.lang.StringUtils;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public class ExpState {
+
+	@ParamAnnotation
+	public int current_number;
+
+	protected final List<Integer> resultList = new ArrayList<>();
+
+	@ParamAnnotation
+	public String getResult() {
+		return StringUtils.join(resultList, ",");
+	}
+
+	@ParamAnnotation
+	public void setResult(String result) {
+		resultList.clear();
+		for (String s : StringUtils.split(result, ",")) {
+			resultList.add(Integer.valueOf(s));
+		}
+	}
+
+	/**
+	 * @return the resultList
+	 */
+	public List<Integer> getResultList() {
+		return resultList;
+	}
+
+	@Override
+	public String toString() {
+		return "(" + current_number + "):" + resultList;
+	}
+}
Index: java/main/src/main/java/com/framsticks/test/prime/PrimePackage.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/prime/PrimePackage.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/test/prime/PrimePackage.java	(revision 102)
@@ -0,0 +1,18 @@
+package com.framsticks.test.prime;
+
+import com.framsticks.experiment.WorkPackage;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+
+@FramsClassAnnotation
+public class PrimePackage implements WorkPackage {
+
+	public final ExpParams params = new ExpParams();
+
+	public final ExpState state = new ExpState();
+
+	@Override
+	public String toString() {
+		return params + " -> " + state;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/AutoAttacher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/AutoAttacher.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/util/AutoAttacher.java	(revision 102)
@@ -0,0 +1,7 @@
+package com.framsticks.util;
+
+public interface AutoAttacher {
+
+	public void attachTo(Object parent);
+
+}
Index: java/main/src/main/java/com/framsticks/util/Misc.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/Misc.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/Misc.java	(revision 102)
@@ -54,3 +54,10 @@
 		return value;
 	}
+
+	public static void checkEquals(Object expected, Object found, String message, Object context) {
+		if (equals(expected, found)) {
+			return;
+		}
+		throw new FramsticksException().msg(message).arg("expected", expected).arg("found", found).arg("in", context);
+	}
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AbstractJoinable.java	(revision 102)
@@ -18,4 +18,5 @@
 
 	private static final Logger log = LogManager.getLogger(AbstractJoinable.class);
+	private static final Logger reportLog = LogManager.getLogger(AbstractJoinable.class.getName() + ".Report");
 
 	protected final Set<JoinableParent> owners = new HashSet<JoinableParent>();
@@ -35,5 +36,10 @@
 	}
 
+
+
 	public static void report() {
+		if (!reportLog.isDebugEnabled()) {
+			return;
+		}
 		StringBuilder b = new StringBuilder();
 		synchronized (joinablesRegistry) {
@@ -42,5 +48,5 @@
 			}
 		}
-		log.debug("state: {}", b);
+		reportLog.debug("state: {}", b);
 	}
 
@@ -53,6 +59,6 @@
 		}
 		this.state = state;
-
-		log.debug("{} is notifying {} parents", this, joinableListeners.size());
+		log.debug("{} changed state to {}", this, state);
+
 
 		List<JoinableParent> parents = new LinkedList<>();
@@ -61,4 +67,5 @@
 		for (JoinableParent p : parents) {
 			if (p != null) {
+				log.debug("{} is notifying parent {} about change to {}", this, p, state);
 				Dispatching.childChangedState(p, this, state);
 			}
@@ -110,7 +117,8 @@
 		}
 		joinableJoin();
-		synchronized (this) {
-			this.state = JoinableState.JOINED;
-		}
+		changeState(JoinableState.JOINED);
+		// synchronized (this) {
+		// 	this.state = JoinableState.JOINED;
+		// }
 	}
 
@@ -158,11 +166,12 @@
 		synchronized (this) {
 			if (!owners.contains(owner)) {
-				return false;
-				// throw new FramsticksException().msg("object is not owning that joinable").arg("joinable", this).arg("object", owner);
+				// log.error("owner {} is not owning that joinable {}", owner, this);
+				// return false;
+				throw new FramsticksException().msg("object is not owning that joinable").arg("joinable", this).arg("object", owner);
 			}
 			// assert owners.containsKey(owner);
-			log.debug("{} is droping {}", owner, this);
 			owners.remove(owner);
 			stop = owners.isEmpty();
+			log.debug("{} is droping {} (users remaining: {})", owner, this, owners);
 		}
 		if (stop) {
@@ -195,5 +204,5 @@
 	@Override
 	public String toString() {
-		return getName();
+		return getClass().getSimpleName() + "(" + getName() + ")";
 	}
 
@@ -203,4 +212,3 @@
 	}
 
-
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/BufferedDispatcher.java	(revision 102)
@@ -2,5 +2,13 @@
 
 
-public class BufferedDispatcher<C> {
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Strings;
+// import static com.framsticks.util.dispatching.AbstractJoinable.wrap;
+
+public class BufferedDispatcher<C> extends AbstractJoinable implements Dispatcher<C>, JoinableParent {
+	private static final Logger log = LogManager.getLogger(BufferedDispatcher.class);
 
 	protected final RunnableQueue<C> queue = new RunnableQueue<>();
@@ -8,5 +16,13 @@
 	protected Dispatcher<C> targetDispatcher;
 
-	protected boolean buffer = false;
+	protected boolean buffer = true;
+	protected Dispatcher<C> parent;
+
+	/**
+	 * @param parent
+	 */
+	public BufferedDispatcher(Dispatcher<C> parent) {
+		this.parent = parent;
+	}
 
 	/**
@@ -21,9 +37,17 @@
 	 */
 	public synchronized void setTargetDispatcher(Dispatcher<C> targetDispatcher) {
+		if (this.targetDispatcher != null) {
+			throw new FramsticksException().msg("dispatcher is already set").arg("dispatcher", this.targetDispatcher).arg("in", this);
+		}
+		if (targetDispatcher == null) {
+			throw new FramsticksException().msg("trying to set empty target dispatcher").arg("in", this);
+		}
+		log.debug("setting {} to {}", this, targetDispatcher);
 		this.targetDispatcher = targetDispatcher;
+		flushQueue();
 	}
 
 	public synchronized boolean isActive() {
-		if (targetDispatcher == null) {
+		if (targetDispatcher == null || buffer) {
 			return false;
 			// throw new FramsticksException().msg("no dispatcher is set for tree yet").arg("tree", this);
@@ -40,4 +64,14 @@
 	}
 
+	protected void flushQueue() {
+		if (this.buffer || targetDispatcher == null) {
+			return;
+		}
+		log.debug("flushing {} tasks in {}", queue.size(), this);
+		while (!queue.isEmpty()) {
+			targetDispatcher.dispatch(queue.pollFirst());
+		}
+	}
+
 	public synchronized void setBuffer(final boolean buffer) {
 		if (this.buffer == buffer) {
@@ -49,10 +83,49 @@
 		}
 		this.buffer = false;
-		while (!queue.isEmpty()) {
-			targetDispatcher.dispatch(queue.pollFirst());
+		flushQueue();
+	}
+
+	@Override
+	public String toString() {
+		return parent + " -> " + Strings.toStringNullProof(targetDispatcher, "<null>");
+	}
+
+	public void createThreadIfNeeded() {
+		if (targetDispatcher != null) {
+			return;
 		}
+		this.setTargetDispatcher(new Thread<C>().setName(parent.getName()));
+	}
+
+	@Override
+	public String getName() {
+		return parent + " buffered dispatcher";
+	}
+
+	@Override
+	protected void joinableStart() {
+		Dispatching.use(targetDispatcher, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(targetDispatcher, this);
+
+		finishJoinable();
+	}
+
+	@Override
+	protected void joinableFinish() {
 
 	}
 
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(targetDispatcher);
+	}
 
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		proceedToState(state);
+	}
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/DispatcherSetable.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/DispatcherSetable.java	(revision 102)
+++ java/main/src/main/java/com/framsticks/util/dispatching/DispatcherSetable.java	(revision 102)
@@ -0,0 +1,7 @@
+package com.framsticks.util.dispatching;
+
+public interface DispatcherSetable<C> {
+	public void setDispatcher(Dispatcher<C> dispatcher);
+	public Dispatcher<C> getDispatcher();
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 102)
@@ -3,8 +3,10 @@
 import java.util.Timer;
 
+import org.apache.logging.log4j.Level;
 import org.apache.logging.log4j.Logger;
 import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 
 /**
@@ -32,4 +34,8 @@
 	}
 
+	public static <C> void dispatch(Dispatcher<C> dispatcher, RunAt<? extends C> runnable) {
+		dispatcher.dispatch(runnable);
+	}
+
 	// public static boolean assertInvokeLater(Dispatcher dispatcher, RunAt runnable) {
 	//	dispatcher.invokeLater(runnable);
@@ -66,4 +72,5 @@
 
 	public static void use(final Joinable joinable, final JoinableParent owner) {
+		Misc.throwIfNull(joinable);
 		log.debug("using {} by {}", joinable, owner);
 		if (joinable.use(owner)) {
@@ -75,4 +82,5 @@
 
 	public static void drop(final Joinable joinable, final JoinableParent owner) {
+		Misc.throwIfNull(joinable);
 		log.debug("droping {} by {}", joinable, owner);
 		if (joinable.drop(owner)) {
@@ -84,4 +92,5 @@
 
 	public static void join(Joinable joinable) throws InterruptedException {
+		Misc.throwIfNull(joinable);
 		log.debug("joining {}", joinable);
 		try {
@@ -95,5 +104,5 @@
 
 	public static void childChangedState(final JoinableParent parent, final Joinable joinable, final JoinableState state) {
-		if (state.ordinal() <= JoinableState.RUNNING.ordinal()) {
+		if (state.ordinal() < JoinableState.RUNNING.ordinal()) {
 			return;
 		}
@@ -113,4 +122,5 @@
 			}
 		} catch (InterruptedException e) {
+			log.debug("failed to wait on {} because of: {}", object, e.getMessage());
 		}
 	}
@@ -123,4 +133,5 @@
 				return;
 			} catch (InterruptedException e) {
+				log.debug("failed to join {} because of: {}", joinable, e.getMessage());
 				// throw new FramsticksException().msg("failed to join").arg("dispatcher", dispatcher).cause(e);
 			}
@@ -192,38 +203,38 @@
 
 	// public static class DispatcherWaiter<C, T extends Dispatcher<C> & Joinable> implements Dispatcher<C> {
-	// 	// protected boolean done = false;
-	// 	protected final T dispatcher;
-	// 	protected RunAt<? extends C> runnable;
-
-	// 	/**
-	// 	 * @param joinable
-	// 	 */
-	// 	public DispatcherWaiter(T dispatcher) {
-	// 		this.dispatcher = dispatcher;
-	// 	}
-
-	// 	public synchronized void waitFor() {
-	// 		while ((runnable == null) && (dispatcher.getState().ordinal() <= JoinableState.RUNNING.ordinal())) {
-	// 			try {
-	// 				this.wait();
-	// 			} catch (InterruptedException e) {
-	// 			}
-	// 		}
-	// 		if (runnable != null) {
-	// 			runnable.run();
-	// 		}
-
-	// 	}
-
-	// 	@Override
-	// 	public boolean isActive() {
-	// 		return dispatcher.isActive();
-	// 	}
-
-	// 	@Override
-	// 	public synchronized void dispatch(RunAt<? extends C> runnable) {
-	// 		this.runnable = runnable;
-	// 		this.notifyAll();
-	// 	}
+	//	// protected boolean done = false;
+	//	protected final T dispatcher;
+	//	protected RunAt<? extends C> runnable;
+
+	//	/**
+	//	 * @param joinable
+	//	 */
+	//	public DispatcherWaiter(T dispatcher) {
+	//		this.dispatcher = dispatcher;
+	//	}
+
+	//	public synchronized void waitFor() {
+	//		while ((runnable == null) && (dispatcher.getState().ordinal() <= JoinableState.RUNNING.ordinal())) {
+	//			try {
+	//				this.wait();
+	//			} catch (InterruptedException e) {
+	//			}
+	//		}
+	//		if (runnable != null) {
+	//			runnable.run();
+	//		}
+
+	//	}
+
+	//	@Override
+	//	public boolean isActive() {
+	//		return dispatcher.isActive();
+	//	}
+
+	//	@Override
+	//	public synchronized void dispatch(RunAt<? extends C> runnable) {
+	//		this.runnable = runnable;
+	//		this.notifyAll();
+	//	}
 
 	// }
@@ -284,3 +295,14 @@
 	}
 
+	public static <C> void dispatchLog(final Dispatcher<C> dispatcher, final Logger logger, final Level level, final Object text) {
+		dispatcher.dispatch(new RunAt<C>(ThrowExceptionHandler.getInstance()) {
+
+			@Override
+			protected void runAt() {
+				logger.log(level, "message dispatched into {}: {}", dispatcher, text);
+			}
+		});
+
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/JoinableCollection.java	(revision 102)
@@ -21,14 +21,24 @@
 	protected final Set<T> joinables = new HashSet<T>();
 
-	protected boolean finishIfOne;
+	public static enum FinishPolicy {
+		Never,
+		OnFirst,
+		OnAll
+	};
+
+	protected final FinishPolicy finishPolicy;
 
 	protected String observableName;
 
 	public JoinableCollection() {
-		this(false);
-	}
-
-	public JoinableCollection(boolean finishIfOne) {
-		this.finishIfOne = finishIfOne;
+		this(FinishPolicy.OnAll);
+	}
+
+
+	/**
+	 * @param finishPolicy
+	 */
+	public JoinableCollection(FinishPolicy finishPolicy) {
+		this.finishPolicy = finishPolicy;
 	}
 
@@ -95,11 +105,12 @@
 
 	protected JoinableState getNextState() {
-		if (joinables.isEmpty()) {
+		if ((finishPolicy == FinishPolicy.Never && state == JoinableState.RUNNING) || joinables.isEmpty()) {
 			return state;
 		}
-		JoinableState result = finishIfOne ? JoinableState.INITILIAZED : JoinableState.JOINED;
+		boolean oneIsEnough = (finishPolicy == FinishPolicy.OnFirst);
+		JoinableState result = oneIsEnough ? JoinableState.INITILIAZED : JoinableState.JOINED;
 		for (Joinable j : joinables) {
 			JoinableState s = j.getState();
-			if (finishIfOne) {
+			if (oneIsEnough) {
 				if (s.ordinal() > result.ordinal()) {
 					result = s;
Index: java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Monitor.java	(revision 102)
@@ -5,4 +5,5 @@
 import com.framsticks.util.dispatching.Dispatching;
 import java.lang.Thread;
+import java.util.concurrent.atomic.AtomicBoolean;
 
 public class Monitor implements JoinableParent {
@@ -12,4 +13,6 @@
 	protected final Joinable joinable;
 	protected final Thread shutdownHook;
+	protected final AtomicBoolean dropped = new AtomicBoolean(false);
+	protected final AtomicBoolean joining = new AtomicBoolean(false);
 
 	/**
@@ -22,6 +25,8 @@
 			@Override
 			public void run() {
-				log.debug("running shutdown hook");
+				log.debug("droping and joining");
 				Monitor.this.drop().join();
+				log.debug("droped and joined");
+				AbstractJoinable.report();
 			}
 		});
@@ -54,4 +59,7 @@
 
 	public Monitor drop() {
+		if (!dropped.compareAndSet(false, true)) {
+			return this;
+		}
 		log.debug("{} is droping", this);
 		Dispatching.drop(joinable, this);
@@ -60,4 +68,9 @@
 
 	public Monitor join() {
+		if (!joining.compareAndSet(false, true)) {
+			log.debug("not joining");
+			return this;
+		}
+
 		log.debug("{} is joining", this);
 		Dispatching.joinAbsolutely(joinable);
@@ -69,5 +82,4 @@
 			/** In case IllegalStateException is caught, it means that JVM is in finalization stage */
 		}
-
 		return this;
 	}
